<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 07/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : language.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Language loader                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sprache-Lader                                    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Try to get language from session
$mx_lang = getSession('mx_lang');

// Set default language if it is not (yet) set
if (is_null($mx_lang)) $mx_lang = getConfig('DEFAULT_LANG');

// Generate filename
$INC = sprintf("inc/language/%s.php", SQL_ESCAPE($mx_lang));

// Look for file
if (!isIncludeReadable($INC)) {
	// Switch to default (DO NOT CHANGE!!!)
	setLanguage('de');
	$INC = 'inc/language/de.php';

	// And set it temporarily
	setConfigEntry('DEFAULT_LANG', 'de');
} // END - if

// Load language file
loadIncludeOnce($INC);

// Check for installation mode
if ((isInstalling()) || (!isInstalled()) || (!isAdminRegistered())) {
	// Load matching language file
	loadInclude('inc/language/install_' . getSession('mx_lang') . '.php');
}

// Remove no more needed variables
unset($mx_lang);
unset($INC);

//
?>
