<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/16/2004 *
 * ===============                              Last change: 10/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : user_functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for user extension             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktionen fuer die user-Erweiterung   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add links for selecting some users
function alpha ($sortby, $colspan, $return=false) {
	if (!REQUEST_ISSET_GET('offset')) REQUEST_SET_GET('offset', 0);
	$add = "&amp;page=".REQUEST_GET('page')."&amp;offset=".REQUEST_GET('offset');
	if (REQUEST_ISSET_GET('mode')) $add .= "&amp;mode=".REQUEST_GET('mode');

	/* Creates the list of letters and makes them a link. */
	$alphabet = explode(',', getMessage('_ALL2') . 'A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z' . getMessage('_OTHERS'));
	$num = count($alphabet) - 1;
	$OUT = '';
	while (list($counter, $ltr) = each($alphabet)) {
		if (REQUEST_GET('letter') == $ltr) {
			// Current letter is letter from URL
			$OUT .= "<strong>".$ltr."</strong>";
		} else {
			// Output link to letter
			$OUT .= "<a href=\"{!URL!}/modules.php?module=admin&amp;what=".getWhat();
			if (REQUEST_ISSET_GET('mode')) $OUT .= "&amp;mode=".REQUEST_GET('mode');
			$OUT .= "&amp;letter=".$ltr."&amp;sortby=".$sortby.$add."\">".$ltr."</a>";
		}

		if ((($counter / getConfig('user_alpha')) == round($counter / getConfig('user_alpha'))) && ($counter > 0)) {
			$OUT .= "&nbsp;]<br />[&nbsp;";
		} elseif ( $counter != $num ) {
			$OUT .= "&nbsp;|&nbsp;";
		}
	} // END - while

	define('__ALPHA_LIST', $OUT);

	// Load template
	$OUT = LOAD_TEMPLATE("admin_list_user_alpha", true);
	if ($return === true) {
		// Return generated code
		return $OUT;
	} else {
		// Output generated code
		OUTPUT_HTML($OUT);
	}
}

// Add links for sorting
function SortLinks ($letter, $sortby, $colspan, $return=false) {
	$OUT = '';
	if (!REQUEST_ISSET_GET('offset')) REQUEST_SET_GET('offset', 0);
	if (!REQUEST_ISSET_GET('page'))   REQUEST_SET_GET('page'  , 0);

	// Add page and offset
	$add = "&amp;page=".REQUEST_GET('page')."&amp;offset=".REQUEST_GET('offset');

	// Add status or mode
	if (REQUEST_ISSET_GET('status'))   $add .= '&amp;mode=' . REQUEST_GET('status');
	elseif (REQUEST_ISSET_GET('mode')) $add .= '&amp;mode=' . REQUEST_GET('mode');

	// Makes order by links..
	if ($letter == "front") $letter = getMessage('_ALL2');

	// Prepare array with all possible sorters
	$list = array(
		'userid'      => getMessage('_UID'),
		'family'      => getMessage('FAMILY_NAME'),
		'email'       => getMessage('ADDY'),
		'REMOTE_ADDR' => getMessage('REMOTE_IP')
	);

	// Add nickname if extension is installed
	if (EXT_IS_ACTIVE('nickname')) {
		$list['nickname'] = getMessage('NICKNAME');
	} // END - if

	foreach ($list as $sort => $title) {
		if ($sortby == $sort) {
			$OUT .= "<strong>" . $title . "</strong>&nbsp;|&nbsp;";
		} else {
			$OUT .= "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_user&amp;letter=" . $letter . "&amp;sortby=" . $sort.$add . "\">" . $title . "</a>&nbsp;|&nbsp;";
		}
	} // END - foreach

	define('__SORT_LIST', substr($OUT, 0, -13));

	// Load template
	$OUT = LOAD_TEMPLATE('admin_list_user_sort', true);
	if ($return === true) {
		// Return code
		return $OUT;
	} else {
		// Output code
		OUTPUT_HTML($OUT);
	}
}

// Add page navigation
function ADD_PAGENAV ($PAGES, $offset, $show_form, $colspan,$return=false) {
	if ($show_form) {
		// Load form for changing number of lines
		define('__FORM_HEADER', LOAD_TEMPLATE('admin_list_user_sort_form', true));
		define('__FORM_FOOTER', '<tr><td colspan="{!__COLSPAN2!}" class="seperator bottom2">&nbsp;</td></tr>');
	} else {
		// Empty row
		define('__FORM_HEADER', '<tr><td colspan="' . $colspan . '" class="seperator">&nbsp;</td></tr>');
		define('__FORM_FOOTER', '<tr><td colspan="{!__COLSPAN2!}" class="seperator bottom2">&nbsp;</td></tr>');
	}

	$OUT = '';
	for ($page = 1; $page <= $PAGES; $page++) {
		if (($page == REQUEST_GET('page')) || ((!REQUEST_ISSET_GET('page')) && ($page == '1'))) {
			$OUT .= '<strong>-';
		} else {
			if (!REQUEST_ISSET_GET('letter')) REQUEST_SET_GET('letter', getMessage('_ALL2'));
			if (!REQUEST_ISSET_GET('sortby')) REQUEST_SET_GET('sortby', 'userid');

			// Base link
			$OUT .= '<a href="{!URL!}/modules.php?module=admin&amp;what=' . getWhat();

			// Add status or mode
			if (REQUEST_ISSET_GET('status'))    $OUT .= '&amp;mode=' . REQUEST_GET('status');
			 elseif (REQUEST_ISSET_GET('mode')) $OUT .= '&amp;mode=' . REQUEST_GET('mode');

			// Letter and so on
			$OUT .= '&amp;letter=' . REQUEST_GET('letter') . '&amp;sortby=' . REQUEST_GET('sortby') . '&amp;page=' . $page . '&amp;offset=' . $offset . '">';
		}

		$OUT .= $page;

		if (($page == REQUEST_GET('page')) || ((!REQUEST_ISSET_GET('page')) && ($page == '1'))) {
			$OUT .= '-</strong>';
		} else 	{
			$OUT .= '</a>';
		}

		if ($page < $PAGES) $OUT .= '&nbsp;|&nbsp;';
	} // END - for

	define('__PAGENAV_LIST', $OUT);

	// Load template
	$OUT = LOAD_TEMPLATE('admin_list_user_pagenav', true);
	if ($return === true) {
		// Return code
		return $OUT;
	} else {
		// Output code
		OUTPUT_HTML($OUT);
	}
}

// Create email link to user's account
function generateUserEmailLink($email, $mod='admin') {
	// Show contact link only if user is confirmed by default
	$locked = " AND `status`='CONFIRMED'";

	// But admins shall always see it
	if (IS_ADMIN()) $locked = '';

	$result = SQL_QUERY_ESC("SELECT `userid`
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE `email`='%s'" . $locked." LIMIT 1",
		array($email), __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Load userid
		list($uid) = SQL_FETCHROW($result);

		// Rewrite email address to contact link
		$email = '{!URL!}/modules.php?module=' . $mod . '&amp;what=user_contct&amp;uid=' . bigintval($uid);
	} // END - if

	// Free memory
	SQL_FREERESULT($result);

	// Return rewritten (?) email address
	return $email;
}

// Selects a random user id as the new referal id if they have at least X confirmed mails in this run
function determineRandomReferalId () {
	// Default is zero refid
	$refid = 0;

	// Is the extension version fine?
	if (GET_EXT_VERSION('user') >= '0.3.4') {
		// Get all user ids
		$totalUsers = GET_TOTAL_DATA('CONFIRMED', 'user_data', 'userid', 'status', true, " AND `rand_confirmed` >= ".getConfig('user_min_confirmed')."");

		// Do we have at least one?
		if ($totalUsers > 0) {
			// Then choose random number
			$randNum = mt_rand(0, ($totalUsers - 1));

			// Look for random user
			$result = SQL_QUERY_ESC("SELECT `userid` FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `status`='CONFIRMED' AND `rand_confirmed` >= %s ORDER BY `rand_confirmed` DESC LIMIT %s, 1",
				array(getConfig('user_min_confirmed'), $randNum), __FUNCTION__, __LINE__);

			// Do we have one entry there?
			if (SQL_NUMROWS($result) == 1) {
				// Use that userid as new referal id
				list($refid) = SQL_FETCHROW($result);

				// Reset this user's counter
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `rand_confirmed`=0 WHERE `userid`=%s LIMIT 1",
					array($refid), __FUNCTION__, __LINE__);
			} // END - if

			// Free result
			SQL_FREERESULT($result);
		} // END - if
	} // END - if

	// Return result
	return $refid;
}

// Do the user login
function USER_DO_LOGIN ($uid, $passwd) {
	// Init variables
	$dmy = '';

	// Add last_login if available
	$lastOnline = '';
	if (GET_EXT_VERSION('sql_patches') >= '0.2.8') {
		$lastOnline = ', last_login';
	} // END - if

	// Init array
	$content = array(
		'password'    => '',
		'userid'      => '',
		'last_online' => 0,
		'last_login'  => 0,
		'hash'        => ''
		);

		// Check login data
		if ((EXT_IS_ACTIVE('nickname')) && (NICKNAME_IS_ACTIVE($uid))) {
			// Nickname entered
			$result = SQL_QUERY_ESC("SELECT `userid`, `password`, `last_online`" . $lastOnline . " FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `nickname`='%s' AND `status`='CONFIRMED' LIMIT 1",
				array($uid), __FUNCTION__, __LINE__);
		} else {
			// Direct userid entered
			$result = SQL_QUERY_ESC("SELECT `userid`, `password`, `last_online`" . $lastOnline . " FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `userid`=%s AND `status`='CONFIRMED' LIMIT 1",
				array($uid, $content['hash']), __FUNCTION__, __LINE__);
		}

		// Load entry
		$content = SQL_FETCHARRAY($result);
		if (!empty($content['userid'])) $uid = bigintval($content['userid']);

		// Is there an entry?
		if ((SQL_NUMROWS($result) == 1) && ((isNicknameUsed($content['userid'] === true) && (!empty($content['userid']))) || ($content['userid'] == $uid))) {
			// Free result
			SQL_FREERESULT($result);

			// Check for old MD5 passwords
			if ((strlen($content['password']) == 32) && (md5($passwd) == $content['password'])) {
				// Just set the hash to the password from DB... :)
				$content['hash'] = $content['password'];
			} else {
				// Hash password with improved way for comparsion
				$content['hash'] = generateHash($passwd, substr($content['password'], 0, -40));
			}

			// Does the password match the hash?
			if ($content['hash'] == $content['password']) {
				// New hashed password found so let's generate a new one
				$content['hash'] = generateHash($passwd);

				// ... and update database
				// @TODO Make this filter working: $ADDON = runFilterChain('post_login_update', $content);
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `password`='%s' WHERE `userid`=%s AND `status`='CONFIRMED' LIMIT 1",
					array($content['hash'], $uid), __FUNCTION__, __LINE__);

				// No login bonus by default
				$GLOBALS['bonus_payed'] = false;

				// Probe for last online timemark
				$probe = time() -  $content['last_online'];
				if (!empty($content['last_login'])) $probe = time() - $content['last_login'];
				if ((GET_EXT_VERSION('bonus') >= '0.2.2') && ($probe >= getConfig('login_timeout'))) {
					// Add login bonus to user's account
					$add = sprintf(", `login_bonus`=`login_bonus`+%s",
					(float)getConfig('login_bonus')
					);
					$GLOBALS['bonus_payed'] = true;

					// Subtract login bonus from userid's account or jackpot
					if ((GET_EXT_VERSION('bonus') >= '0.3.5') && (getConfig('bonus_mode') != 'ADD')) BONUS_POINTS_HANDLER('login_bonus');
				} // END - if

				// Calculate new hash with the secret key and master salt together
				$content['hash'] = generatePassString($content['hash']);

				// Update global array
				// @TODO Make this filter working: $URL = runFilterChain('do_login', array('content' => $content, 'addon' => $ADDON));
				setUserId($uid);

				// Try to set session data (which shall normally always work!)
				if ((setSession('userid', $uid )) && (setSession('u_hash', $content['hash']))) {
					// Update database records
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `total_logins`=`total_logins +1" . $add . " WHERE `userid`=%s LIMIT 1",
						array($uid), __FUNCTION__, __LINE__);
					if (SQL_AFFECTEDROWS() == 1) {
						// Procedure to checking for login data
						if (($GLOBALS['bonus_payed']) && (EXT_IS_ACTIVE('bonus'))) {
							// Bonus added (just displaying!)
							$URL = 'modules.php?module=chk_login&amp;mode=bonus';
						} else {
							// Bonus not added
							$URL = 'modules.php?module=chk_login&amp;mode=login';
						}
					} else {
						// Cannot update counter!
						$URL = 'modules.php?module=index&amp;what=login&amp;login='.getCode('CNTR_FAILED');
					}
				} else {
					// Cookies not setable!
					$URL = 'modules.php?module=index&amp;what=login&amp;login='.getCode('NO_COOKIES');
				}
			} elseif (GET_EXT_VERSION('sql_patches') >= '0.6.1') {
				// Update failture counter
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `login_failures`=`login_failures`+1,`last_failure`=NOW() WHERE `userid`=%s LIMIT 1",
					array($uid), __FUNCTION__, __LINE__);

				// Wrong password!
				$URL = 'modules.php?module=index&amp;what=login&amp;login='.getCode('WRONG_PASS');
			}
		} elseif (((isNicknameUsed($content['userid'])) && (!empty($content['userid']))) || ($content['userid'] == $uid)) {
			// Other account status?
			// @TODO Can this query be merged with above query?
			$result = SQL_QUERY_ESC("SELECT status FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `userid`=%s LIMIT 1",
				array($uid), __FUNCTION__, __LINE__);

			// Entry found?
			if (SQL_NUMROWS($result) == 1) {
				// Load status
				list($status) = SQL_FETCHROW($result);

				// Create an error code from given status
				$errorCode = generateErrorCodeFromUserStatus($status);
			} else {
				// ID not found!
				$errorCode = getCode('WRONG_ID');
			}

			// Construct URL
			$URL = 'modules.php?module=index&amp;what=login&amp;login='.$errorCode;
		} else {
			// ID not found!
			$URL = 'modules.php?module=index&amp;what=login&amp;login='.getCode('WRONG_ID');
		}

		// Return URL
		return $URL;
}

// Try to send a new password for the given user account
function USER_DO_NEW_PASSWORD ($email, $uid) {
	// Compile email when found in address (only secure chars!)
	if (!empty($email)) $email = str_replace('{DOT}', '.', $email);

	// Init result and error
	$errorCode = '';
	$result = false;

	// Probe userid/nickname
	if ((EXT_IS_ACTIVE('nickname')) && (NICKNAME_IS_ACTIVE($uid))) {
		// Nickname entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `nickname`='%s' OR `email`='%s' LIMIT 1",
			array($uid, $email), __FUNCTION__, __LINE__);
	} elseif (($uid > 0) && (empty($email))) {
		// Direct userid entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `userid`=%s LIMIT 1",
			array(bigintval($uid)), __FUNCTION__, __LINE__);
	} elseif (!empty($email)) {
		// Email entered
		$result = SQL_QUERY_ESC("SELECT `userid`, `status` FROM `{!_MYSQL_PREFIX!}_user_data` WHERE `email`='%s' LIMIT 1",
			array($email), __FUNCTION__, __LINE__);
	} else {
		// Userid not set!
		DEBUG_LOG(__FUNCTION__, __LINE__, 'Userid is not set! BUG!');
		$errorCode = getCode('WRONG_ID');
	}

	// Any entry found?
	if (SQL_NUMROWS($result) == 1) {
		// This data is valid, so we create a new pass... :-)
		list($uid, $status) = SQL_FETCHROW($result);

		if ($status == 'CONFIRMED') {
			// Ooppps, this was missing! ;-) We should update the database...
			$NEW_PASS = generatePassword();
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `password`='%s' WHERE `userid`=%s LIMIT 1",
				array(generateHash($NEW_PASS), $uid), __FUNCTION__, __LINE__);

			// Prepare data and message for email
			$msg = LOAD_EMAIL_TEMPLATE('new-pass', array('new_pass' => $NEW_PASS), $uid);

			// ... and send it away
			sendEmail($uid, getMessage('GUEST_NEW_PASSWORD'), $msg);

			// Output note to user
			LOAD_TEMPLATE('admin_settings_saved', false, getMessage('GUEST_NEW_PASSWORD_SEND'));
		} else {
			// Account is locked or unconfirmed
			$errorCode = generateErrorCodeFromUserStatus($status);

			// Load URL
			redirectToUrl('modules.php?module=index&amp;what=login&amp;login='.$errorCode);
		}
	} else {
		// ID or email is wrong
		LOAD_TEMPLATE('admin_settings_saved', false, '<span class="guest_failed">{--GUEST_WRONG_ID_EMAIL--}</span>');
	}

	// Return the error code
	return $errorCode;
}

// [EOF]
?>
